package org.planet.snap;

import java.io.File;
import java.io.IOException;
import java.lang.reflect.Method;
import java.net.URL;
import java.net.URLClassLoader;

public class ClasspathHacker {
    private static final Class[] parameters = new Class[]{URL.class};

    public static void addFile(String s, URLClassLoader ucl) throws IOException {
        File f = new File(s);
        addFile(f, ucl);
    }
    
    public static void addFile(File f, URLClassLoader ucl) throws IOException {
        addURL(f.toURL(), ucl);
    }
	
    public static void addURL(URL u, URLClassLoader ucl) throws IOException {
		URLClassLoader sysloader;
		if(ucl==null) {
			sysloader = (URLClassLoader)ClassLoader.getSystemClassLoader();
		}else{
			sysloader = ucl;
		}
		
        Class sysclass = URLClassLoader.class;
        
		try {
            Method method = sysclass.getDeclaredMethod("addURL",parameters);
            method.setAccessible(true);
            method.invoke(sysloader,new Object[]{ u }); 
        } catch (Throwable t) {
            t.printStackTrace();
            throw new IOException("Error, could not add URL to system classloader");
        }
    }
}
