package org.planet.snap.deployer;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

public class MainWizardDialog extends TitleAreaDialog {
  private SnapDeployer win;

  public MainWizardDialog (Shell parentShell, SnapDeployer wd) {
    super (parentShell);
    win = wd;
  }

  protected Control createDialogArea (Composite parent) {
    Composite area = (Composite) super.createDialogArea (parent);
    Composite container = new Composite(area, SWT.NONE);
    container.setLayoutData (new GridData(GridData.FILL_BOTH));

    super.getShell().setText ("Snap Deployer");
    Image img = new Image (super.getShell().getDisplay(), "./images/snap_installer.jpg");
    super.getShell().setImage (img);

    setTitle ("SNAP Web Application Signer and Deployer Wizard");
    setMessage ("Welcome to SNAP's Web Application Signer and Deployer Wizard.");
    setTitleImage (img);

    final Label label = new Label(container, SWT.NONE);
    label.setBounds(15, 27, 450, 140);
    label.setText("This wizard allows you to sign & deploy all of the received Web Application archives which are\nintended to be deployed on the Structured overlay Network Application Platform (SNAP).\n\n" +
                  "You will be prompted for you own pair of public/private keys for signing WAR files. Moreover,\nyou will be asked to supply the web application archive to be signed and deployed into SNAP.\n\n" +
                  "If you do not have a pair of usable public/private keys, a new pair will automatically be\ngenerated for you.");

    final Label label_1 = new Label(container, SWT.SEPARATOR | SWT.HORIZONTAL);
    label_1.setBounds (7, 200, 485, 5);

    return area;
  }

  protected void createButtonsForButtonBar (Composite parent) {
    createButton(parent, IDialogConstants.NEXT_ID, IDialogConstants.NEXT_LABEL,
                 true);
    createButton(parent, IDialogConstants.CANCEL_ID,
                 IDialogConstants.CANCEL_LABEL, false);

    Button cancel = getButton (IDialogConstants.CANCEL_ID);
    cancel.addSelectionListener (new SelectionAdapter() {
      public void widgetSelected(SelectionEvent event) {
        close();
      }
    });

    Button ok = getButton (IDialogConstants.NEXT_ID);
    ok.addSelectionListener (new SelectionAdapter() {
      public void widgetSelected(SelectionEvent event) {
        Point p = getShell().getLocation();
        close();
        win.openMainOptionsDialog (p);
      }
    });
  }

  protected Point getInitialSize() {
    return new Point(500, 375);
  }
}
