package org.planet.snap.deployer;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public class WarFileChooserDialog extends TitleAreaDialog {
  private Text p2pUrl;
  private Text text;
  private Text passwd;
  private Button next;
  private SnapDeployer win;

  public WarFileChooserDialog (Shell parentShell, SnapDeployer wd) {
    super (parentShell);
    win = wd;
  }

  protected Control createDialogArea (Composite parent) {
    Composite area = (Composite) super.createDialogArea(parent);
    Composite container = new Composite(area, SWT.NONE);
    container.setLayoutData(new GridData(GridData.FILL_BOTH));

    super.getShell().setText ("Snap Deployer");
    Image img = new Image (super.getShell().getDisplay(), "./images/snap_installer.jpg");
    super.getShell().setImage (img);

    setTitle ("SNAP Web Application Signer and Deployer Wizard");
    setMessage ("Choose web application archive to sign and deploy into SNAP.");
    setTitleImage (img);

    final Label label = new Label(container, SWT.NONE);
    label.setBounds(15, 27, 450, 28);
    label.setText ("Please choose the web application's file to be signed and deployed into SNAP, as well as its\nP2P URL identifier:");

    text = new Text(container, SWT.BORDER);
    text.setBounds(118, 83, 272, 20);

    final Label label_1 = new Label(container, SWT.NONE);
    label_1.setBounds(59, 85, 54, 20);
    label_1.setText("WAR File:");

    final Button browseButton = new Button(container, SWT.NONE);
    browseButton.setBounds(396, 82, 54, 23);
    browseButton.setText("Browse...");
    browseButton.addSelectionListener (new SelectionAdapter() {
      public void widgetSelected(SelectionEvent event) {
        String value = onBrowse_click();
        if (value != null) {
          text.setText (value);
          next.setEnabled (true);
        }
      }
    });

    final Label label_2 = new Label(container, SWT.NONE);
    label_2.setBounds (22, 122, 92, 15);
    label_2.setText ("Application's URL:");

    p2pUrl = new Text(container, SWT.BORDER);
    p2pUrl.setText ("p2p://");
    p2pUrl.setBounds (118, 120, 272, 20);

    final Label label_3 = new Label(container, SWT.NONE);
    label_3.setBounds (25, 162, 92, 15);
    label_3.setText ("Admin Password:");

    passwd = new Text(container, SWT.BORDER);
    passwd.setBounds (118, 160, 272, 20);

    final Label label_4 = new Label(container, SWT.SEPARATOR | SWT.HORIZONTAL);
    label_4.setBounds (7, 200, 485, 5);

    return area;
  }

  protected String onBrowse_click () {
    try {
      FileDialog fileChooser = new FileDialog(getShell(), SWT.OPEN);
      fileChooser.setFilterExtensions(new String[]{"*.war"});
      fileChooser.setFilterNames(new String[]{"Web Application Archive (*.war)"});
      return fileChooser.open();
    }
    catch (Exception ex) {
      ex.printStackTrace();
      return null;
    }
  }

  protected void createButtonsForButtonBar(Composite parent) {
    createButton (parent, IDialogConstants.BACK_ID, IDialogConstants.BACK_LABEL, false);
    createButton (parent, IDialogConstants.NEXT_ID, IDialogConstants.NEXT_LABEL, true);
    createButton (parent, IDialogConstants.CANCEL_ID, IDialogConstants.CANCEL_LABEL, false);

    Button cancel = getButton (IDialogConstants.CANCEL_ID);
    cancel.addSelectionListener (new SelectionAdapter() {
      public void widgetSelected(SelectionEvent event) {
        close();
      }
    });

    next = getButton (IDialogConstants.NEXT_ID);
    next.setEnabled (false);
    next.addSelectionListener (new SelectionAdapter() {
      public void widgetSelected(SelectionEvent event) {
        String warFile = text.getText();
        String p2p = p2pUrl.getText();
        String password = passwd.getText();
        Point p = getShell().getLocation();
        close();
        // Comprovar que p2pUrl es valida (fins i tot mirar si bound, etc)
        win.openSignAndDeployWarFileDialog (p, warFile, p2p, password);
      }
    });

    Button back = getButton (IDialogConstants.BACK_ID);
    back.setEnabled (true);
    back.addSelectionListener (new SelectionAdapter() {
      public void widgetSelected(SelectionEvent event) {
        Point p = getShell().getLocation();
        close();
        win.openKeyGenDialog (p, true);
      }
    });
  }

  protected Point getInitialSize() {
    return new Point(500, 375);
  }
}
